/* ========================================================================= */
/* Description: definition of class EzbcDec3d                                */
/* Author: Shih-Ta Hsiang                                                    */
/* Version: v0.a                                                             */
/* Last Revised: Aug. 15, 2000                                               */
/* ========================================================================= */

#ifndef __EZBC_DEC_3D_H__
#define __EZBC_DEC_3D_H__

#include "dwt_bitplane_dec.h"
#include "ezbc_codec_3d.h"

class EzbcDec3d: public EzbcCodec3d
{
 protected:
  DECODER_TYPE *decoder;
  DEC_SUBBAND_TREE_TYPE *decY, *decU, *decV;

 public:
  EzbcDec3d(void);
  EzbcDec3d(videoinfo &info, DECODER_TYPE *dec);
  ~EzbcDec3d(void);
  void initialization(void);
  void reset_GOP_dec(void);
  void reset_pyrs(void);
  void reconstruct_images(YUVimage *Frs);
  void decode_GOP_header(void);
  void decode_GOP_subbitplane_passes(void);
  //  void decode_GOP_single_pass(void);
  void decode_GOP_RD_passes(void);
  void decode_GOP_RD_passes2(void);
  void decode_GOP(void);
  void reconstruct_subbands(void);
  void free_lists(void);
};



#endif
